/****************************************************************************
 *
 * Filename:    ps2000Wrap.h
 * Copyright:   Pico Technology Limited 2012
 * Author:      HSM
 * Description:
 *
 * This header defines the interface to the wrapper dll for the 
 *	PicoScope2000 series of PC Oscilloscopes.
 *
 ****************************************************************************/
#ifndef __PS2000WRAP_H__
#define __PS2000WRAP_H__

#include "PS2000.h"

#ifdef __cplusplus
	#define PREF0 extern "C"
	#define TYPE_ENUM
#else
	#define PREF0
	#define TYPE_ENUM enum
#endif

#ifdef WIN32
	typedef unsigned __int64 u_int64_t;
	#ifdef PREF1
	  #undef PREF1
	#endif
	#ifdef PREF2
	  #undef PREF2
	#endif
	#ifdef PREF3
	  #undef PREF3
	#endif
	/*	If you are dynamically linking PS2000.DLL into your project #define DYNLINK here
	 */
	#ifdef DYNLINK
	  #define PREF1 typedef
		#define PREF2
		#define PREF3(x) (__stdcall *x)
	#else
	  #define PREF1
		#ifdef _USRDLL
			#define PREF2 __declspec(dllexport) __stdcall
		#else
			#define PREF2 __declspec(dllimport) __stdcall
		#endif
	  #define PREF3(x) x
	#endif
#else
	/* Define a 64-bit integer type */
	#include <stdint.h>

	#ifdef DYNLINK
		#define PREF1 typedef
		#define PREF2
		#define PREF3(x) (*x)
	#else
		#ifdef _USRDLL
			#define PREF1 __attribute__((visibility("default")))
		#else
			#define PREF1
		#endif
		#define PREF2
		#define PREF3(x) x
	#endif
	#define __stdcall
#endif

extern short __declspec(dllexport) __stdcall PollFastStreaming(short handle);

extern void __declspec(dllexport) __stdcall SetBuffer(short handle, short channel, short * buffer, unsigned long bufferSize);

extern void __declspec(dllexport) __stdcall SetAggregateBuffer(short handle, short channel, short * bufferMax, short * bufferMin, unsigned long bufferSize);

extern short __declspec(dllexport) __stdcall FastStreamingReady(short handle);




#endif